JUCE: ValueTreeSynchroniser Class Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
ValueTreeSynchroniser Class Referenceabstract
juce_data_structures » values

This class can be used to watch for all changes to the state of a ValueTree, and to convert them to a transmittable binary encoding. More...

`#include <juce_ValueTreeSynchroniser.h>`

Inheritance diagram for ValueTreeSynchroniser:

## Public Member Functions
| ValueTreeSynchroniser (const ValueTree &tree)
| Creates a ValueTreeSynchroniser that watches the given tree. More...
| ~ValueTreeSynchroniser () override
| Destructor. More...
virtual void | stateChanged (const void *encodedChange, size_t encodedChangeSize)=0
| This callback happens when the ValueTree changes and the given state-change message needs to be applied to any other trees that need to stay in sync with it. More...
void | sendFullSyncCallback ()
| Forces the sending of a full state message, which may be large, as it encodes the entire ValueTree. More...
const ValueTree & | getRoot () noexcept
| Returns the root ValueTree that is being observed. More...

## Static Public Member Functions
static bool | applyChange (ValueTree &target, const void *encodedChangeData, size_t encodedChangeDataSize, UndoManager *undoManager)
| Applies an encoded change to the given destination tree. More...

## Detailed Description

This class can be used to watch for all changes to the state of a ValueTree, and to convert them to a transmittable binary encoding.

The purpose of this class is to allow two or more ValueTrees to be remotely synchronised by transmitting encoded changes over some kind of transport mechanism.

To use it, you'll need to implement a subclass of ValueTreeSynchroniser and implement the stateChanged() method to transmit the encoded change (maybe via a network or other means) to a remote destination, where it can be applied to a target tree.

## Constructor & Destructor Documentation

## ◆ ValueTreeSynchroniser()

ValueTreeSynchroniser::ValueTreeSynchroniser | ( | const ValueTree & | tree | ) |

Creates a ValueTreeSynchroniser that watches the given tree.

After creating an instance of this class and somehow attaching it to a target tree, you probably want to call sendFullSyncCallback() to get them into a common starting state.

## ◆ ~ValueTreeSynchroniser()

ValueTreeSynchroniser::~ValueTreeSynchroniser | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ stateChanged()

virtual void ValueTreeSynchroniser::stateChanged | ( | const void * | encodedChange,
|  | size_t | encodedChangeSize
| ) |  |
| pure virtual

This callback happens when the ValueTree changes and the given state-change message needs to be applied to any other trees that need to stay in sync with it.

The data is an opaque blob of binary that you should transmit to wherever your target tree lives, and use applyChange() to apply this to the target tree.

## ◆ sendFullSyncCallback()

void ValueTreeSynchroniser::sendFullSyncCallback | ( |  | ) |

Forces the sending of a full state message, which may be large, as it encodes the entire ValueTree.

This will internally invoke stateChanged() with the encoded version of the state.

## ◆ applyChange()

static bool ValueTreeSynchroniser::applyChange | ( | ValueTree & | target,
|  | const void * | encodedChangeData,
|  | size_t | encodedChangeDataSize,
|  | UndoManager * | undoManager
| ) |  |
| static

Applies an encoded change to the given destination tree.

When you implement a receiver for changes that were sent by the stateChanged() message, this is the function that you'll need to call to apply them to the target tree that you want to be synced.

## ◆ getRoot()

const ValueTree & ValueTreeSynchroniser::getRoot | ( |  | ) |
| noexcept

Returns the root ValueTree that is being observed.

The documentation for this class was generated from the following file:

- juce_ValueTreeSynchroniser.h